CON

    Nunchuck_Addr = $A4
{

1 - green - data
2 - nothing
3 - red - 3.3+v
4 - yellow - clock
5 - nothing
6 - white - ground

}
OBJ
   i2cObject2      :  "ECi2c" 

VAR
   word accel_x
   word accel_y
   word accel_z
   long _220uS
   byte i2cSCL, i2cSDA
PUB init(_scl, _sda)
   i2cSCL := _scl
   i2cSDA := _sda
   i2cObject2.Init(i2cSDA, i2cSCL)
   _220uS := clkfreq / 100_000 * 22 
   i2cObject2.writelocation(Nunchuck_Addr, $40, $00)
  
PUB readNunchuck | data[6]
   i2cObject2.writelocation(Nunchuck_Addr, $0, $00)
   waitcnt(_220uS+cnt)
   i2cObject2.i2cStart
   i2cObject2.i2cWrite(Nunchuck_Addr)
   i2cObject2.i2cWrite(0)
   i2cObject2.i2cStop
   waitcnt(_220uS+cnt)
   i2cObject2.i2cStart
   i2cObject2.i2cWrite(Nunchuck_Addr|1)
   data[0] := (i2cObject2.i2cRead(0) ^ $17) + $17 
   data[1] := (i2cObject2.i2cRead(0) ^ $17) + $17 
   data[2] := (i2cObject2.i2cRead(0) ^ $17) + $17 'accl x value decoded
   data[3] := (i2cObject2.i2cRead(0) ^ $17) + $17 'accl y value decoded
   data[4] := (i2cObject2.i2cRead(0) ^ $17) + $17 'accl z value decoded
   data[5] := (i2cObject2.i2cRead(1) ^ $17) + $17 'lower bits of xyz data
   i2cObject2.i2cStop
   accel_x := data[2] << 2
   accel_y := data[3] << 2
   accel_z := data[4] << 2
   if (data[5] >> 2) & 1
      accel_x += 2                                                                               
   if (data[5] >> 3) & 1
      accel_x += 1                                                                               
   if (data[5] >> 4) & 1
      accel_y += 2                                                                               
   if (data[5] >> 5) & 1
      accel_y += 1                                                                               
   if (data[5] >> 6) & 1
      accel_z += 2                                                                               
   if (data[5] >> 7) & 1
      accel_z += 1


PUB accelX
   return accel_x

PUB accelY
   return accel_y

PUB accelZ
   return accel_z